package automat;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <p>Title: Pokladna</p><br>
 * <p>Author: Josef Jebavy</p><br>
 *
 * <p>Description: Placeni nakupu</p><br>
 *
 * <p>Copyright: tento program je  siren pod licenci GPL v2</p><br>
 *
 * <p>Company: Multi</p><br>
 * <p>Jabber: multi(at)jabber.sh.cvut.cz</p><br>
 * <p>ICQ: 281213073</p><br>
 * <p>e-mail:joepage@quick.cz</p><br>
 *  <p>web:<a href="www.sweb.cz/joepage">www.sweb.cz/joepage</a></p><br>
 * @author Josef Jebavy
 * @version 1.8
 */
public class Pokladna
    extends JFrame {
  Container kontak;
  JButton zpetBT, platitBT;
  int platba;
  JLabel hodnotaJl, pocetJL;
  JLabel[] bankovky;
  JTextField[] pocet;
  int[] hodnota;

  Odchod odchod;

  int utrata;
  Nabidka[] nabidka;
  Kom kom;
  InOut inOut;

  public Pokladna(Nabidka[] nabidka, int utrata) {
    super("Pokladna");
    this.utrata = utrata;
    this.nabidka = nabidka;
    setSize(400, 400);
    this.setLocation(400,0);
    odchod = new Odchod();
    setDefaultCloseOperation(Close() /*JFrame.EXIT_ON_CLOSE*/);

    setVisible(false);

    hodnota = inOut.PoleRetezcuNaInt(inOut.CtiSouboruPoRadcich(kom.bankovky));
    //**kontejner
     kontak = getContentPane();

    //**rozházení do Layoutu
     // FlowLayout rozmisteni = new FlowLayout();
     GridLayout rozmisteni = new GridLayout(1 * hodnota.length + 2, 1);

    kontak.setLayout(rozmisteni);

    bankovky = new JLabel[hodnota.length];
    pocet = new JTextField[hodnota.length];
    //
    hodnotaJl = new JLabel(kom.hodBan);
    kontak.add(hodnotaJl);
    hodnotaJl.setHorizontalAlignment(hodnotaJl.CENTER);
    pocetJL = new JLabel(kom.zadejPocBan);
    kontak.add(pocetJL);
    pocetJL.setHorizontalAlignment(pocetJL.CENTER);
    //  pole JCheckBox
    for (int i = 0; i < hodnota.length; i++) {

      bankovky[i] = new JLabel(hodnota[i] + " " + kom.mena + "         ");
      kontak.add(bankovky[i]);
      bankovky[i].setHorizontalAlignment(bankovky[i].RIGHT);
      pocet[i] = new JTextField(0);
      kontak.add(pocet[i]);
      //     pocet[i].addActionListener(new PosluchacSpocitatBT());
    }
    //**vraceni se ,posluchc je o uroven vise
     zpetBT = new JButton(kom.zpet);
    kontak.add(zpetBT);
    //**BT placeni

     //**odchod z kseftu
      platitBT = new JButton(kom.platOtd);
    kontak.add(platitBT);
    platitBT.addActionListener(new PosluchacPlatitBT());

    //**konec kontaku
     setContentPane(kontak);
    odchod.button.addActionListener(new PosluchacOdchodBT());

  }

  /**
   *
   *posluchac placeni
   */

  class PosluchacPlatitBT
      implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      Skryt(true);

      Spocitej();

    }

  }

  /**
   *
   *posluchac odchodu
   */

  class PosluchacOdchodBT
      implements ActionListener {
    public void actionPerformed(ActionEvent e) {

      if (platba < utrata) {
        Skryt(false);
      }
      else {

        inOut.ZapsatDoSouboru(kom.placeno + platba + kom.mena + "\n" +
                              kom.vraceno +
                              (platba - utrata) + kom.mena, kom.ucet, false);
        System.exit(0);
      }

    }

  }

  /**
   * Skryt
   *
   * @param b boolean
   */
  public void Skryt(boolean b) {

    setVisible(!b);
    odchod.setVisible(b);
  }

  /**
   * Spocitej
   */
  public void Spocitej() {

    platba = 0;

    for (int i = 0; i < hodnota.length; i++) {

      // String retezec = pocet[i].getText().trim();
      int pocetInt;

      try {
        pocetInt = (int) Double.parseDouble( (pocet[i].getText().trim()));

      }

      catch (Exception e) {
        pocetInt = 0;
      }

      platba += hodnota[i] * pocetInt;

    }
    if (platba < utrata) {
      odchod.label.setText(kom.priplatte + (utrata - platba) + " " + kom.mena);

    }
    else {
      odchod.label.setText(kom.vratime + (platba - utrata) + " " + kom.mena);
      odchod.label2.setText(kom.ucetMate + kom.ucet);
    }

  }

  /**
   * Close
   *
   * @return int
   */
  private int Close() {
    return 0;
  }

  /**public static void main(String[] args) {
    //  Pokladna pokladna = new Pokladna();
    //pokladna.setVisible(true);
     }/**/
}
